## OPEN SOURCE SOFTWARE NOTICE
Please note we provide an open source software notice along with this product and/or this product firmware (in the following just “this product”). The open source software licenses are granted by the respective right holders. And the open source licenses prevail all other license information with regard to the respective open source software contained in the product, including but not limited to End User Software Licensing Agreement. This notice is provided on behalf of Huawei Technologies Co. Ltd. and any of its local subsidiaries which may have provided this product to you in your local country.

### Warranty Disclaimer
THE OPEN SOURCE SOFTWARE IN THIS PRODUCT IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT ANY WARRANTY, WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE APPLICABLE LICENSES FOR MORE DETAILS.

### Copyright Notice and License Texts

**Software :** github.com/AlecAivazis/survey/v2 v2.2.14

**Copyright notice :** Copyright (c) 2018 Alec Aivazis
Copyright 2013 The Go Authors
Copyright 2011 The Go Authors
Copyright (c) 2014 Takashi Kokubun

**License :** MIT License

 
  
  MIT License 
  
  
  Copyright (c) <year> <copyright holders>  
  
 Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: 
 The above copyright notice and this permission notice (including the next paragraph) shall be included in all copies or substantial portions of the Software. 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 



**Software :** github.com/Netflix/go-expect v0.0.0-20180615182759-c93bf25de8e8

**Copyright notice :** Copyright 2018 Netflix, Inc.

**License :** Apache License 2.0

 
  
  Apache License  Version 2.0, January 2004  http://www.apache.org/licenses/  
  
  
  TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 
  
  
   1. Definitions. 
    
     "License" shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document.  
     "Licensor" shall mean the copyright owner or entity authorized by the copyright owner that is granting the License.  
     "Legal Entity" shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, "control" means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity.  
     "You" (or "Your") shall mean an individual or Legal Entity exercising permissions granted by this License.  
     "Source" form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files.  
     "Object" form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types.  
     "Work" shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below).  
     "Derivative Works" shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof.  
     "Contribution" shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, "submitted" means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as "Not a Contribution."  
     "Contributor" shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work.  
     
   2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form.  
   3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed.  
   4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: 
    
     (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and  
     (b) You must cause any modified files to carry prominent notices stating that You changed the files; and  
     (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and  
     (d) If the Work includes a "NOTICE" text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License.  
     
   5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions.  
   6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file.  
   7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License.  
   8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages.  
   9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability.  
  
  
  END OF TERMS AND CONDITIONS 
  APPENDIX: How to apply the Apache License to your work. 
  To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets "[]" replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same "printed page" as the copyright notice for easier identification within third-party archives. 
  Copyright [yyyy] [name of copyright owner] 
  Licensed under the Apache License, Version 2.0 (the "License");  you may not use this file except in compliance with the License.  You may obtain a copy of the License at  
  http://www.apache.org/licenses/LICENSE-2.0 
  Unless required by applicable law or agreed to in writing, software  distributed under the License is distributed on an "AS IS" BASIS,  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the specific language governing permissions and  limitations under the License.  
  



**Software :** github.com/VividCortex/ewma v1.2.0

**Copyright notice :** Copyright (c) 2013 VividCortex

**License :** MIT License

Please see above.


**Software :** github.com/cheggaaa/pb/v3 v3.0.8

**Copyright notice :** Copyright (c) 2012-2015, Sergey Cherepanov
Copyright 2013 The Go Authors

**License :** BSD 3-Clause "New" or "Revised" License

 
  
  Copyright (c) <year> <owner>.
  
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
  
   1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
  
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


**Software :** github.com/clbanning/mxj v1.8.5-0.20200714211355-ff02cfb8ea28

**Copyright notice :** https://github.com/clbanning/mxj

**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** github.com/clbanning/mxj v1.8.5-0.20200714211355-ff02cfb8ea28

**Copyright notice :** https://github.com/clbanning/mxj

**License :** MIT License

Please see above.


**Software :** github.com/clbanning/mxj/v2 v2.5.5

**Copyright notice :** Copyright 2012-2019, Charles Banning
Copyright 2016 Charles Banning
Copyright 2012-2014 Charles Banning
Copyright (c) 2012-2021 Charles Banning <clbanning@gmail.com>
Copyright 2012-2014, 2018 Charles Banning
Copyright 2012-2017 Charles Banning
Copyright 2012-2014, 2017 Charles Banning
Copyright 2012-2016, 2018-2019 Charles Banning
Copyright 2012-2016, 2019 Charles Banning
Copyright (c) 2012-2016 Charles Banning <clbanning@gmail.com>
Copyright 2012-2018 Charles Banning


**License :** MIT License

Please see above.


**Software :** github.com/davecgh/go-spew v1.1.1

**Copyright notice :** Copyright (c) 2012-2016 Dave Collins <dave@davec.name>
Copyright (c) 2013-2016 Dave Collins <dave@davec.name>
Copyright (c) 2013 Dave Collins <dave@davec.name>
Copyright (c) 2015-2016 Dave Collins <dave@davec.name>

**License :** ISC License

 
  
   ISC License 
  
  
  Copyright (c) 2004-2010 by Internet Systems Consortium, Inc. ("ISC")  Copyright (c) 1995-2003 by Internet Software Consortium  
  
 Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies. 
 THE SOFTWARE IS PROVIDED "AS IS" AND ISC DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL ISC BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 



**Software :** github.com/emmansun/gmsm v0.16.0

**Copyright notice :** No copyright info provided

**License :** MIT License

Please see above.


**Software :** github.com/emmansun/gmsm v0.16.0

**Copyright notice :** No copyright info provided

**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** github.com/emmansun/gmsm v0.16.0

**Copyright notice :** No copyright info provided

**License :** BSD 1-Clause License

 
  
   Copyright (c) <year> <owner> All rights reserved.  
  
  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:  
  
   1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.  
  
  THIS SOFTWARE IS PROVIDED BY Berkeley Software Design, Inc. "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL Berkeley Software Design, Inc. BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  



**Software :** github.com/fatih/color v1.13.0

**Copyright notice :** Copyright (c) 2013 Fatih Arslan

**License :** MIT License

Please see above.


**Software :** github.com/google/uuid v1.3.0

**Copyright notice :** Copyright 2016 Google Inc.
Copyright 2021 Google Inc.
Copyright 2017 Google Inc.
Copyright (c) 2009,2014 Google Inc.
Copyright 2018 Google Inc.

**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** github.com/hinshun/vt10x v0.0.0-20180616224451-1954e6464174

**Copyright notice :** Copyright (c) 2013 James Gray

**License :** MIT License

Please see above.


**Software :** github.com/jmespath/go-jmespath v0.4.0

**Copyright notice :** Copyright 2015 James Saryerwinnie

**License :** Apache License 2.0

Please see above.


**Software :** github.com/jmespath/go-jmespath/internal/testify v1.5.1

**Copyright notice :** Copyright (c) 2012-2018 Mat Ryer and Tyler Bunnell

**License :** MIT License

Please see above.


**Software :** github.com/kballard/go-shellquote v0.0.0-20180428030007-95032a82bc51

**Copyright notice :** Copyright (C) 2014 Kevin Ballard

**License :** MIT License

Please see above.


**Software :** github.com/kr/pty v1.1.4

**Copyright notice :** Copyright (c) 2011 Keith Rarick

**License :** MIT License

Please see above.


**Software :** github.com/mattn/go-colorable v0.1.9

**Copyright notice :** Copyright (c) 2016 Yasuhiro Matsumoto


**License :** MIT License

Please see above.


**Software :** github.com/mattn/go-isatty v0.0.14

**Copyright notice :** Copyright (c) Yasuhiro MATSUMOTO <mattn.jp@gmail.com>

**License :** MIT License

Please see above.


**Software :** github.com/mattn/go-runewidth v0.0.12

**Copyright notice :** Copyright (c) 2016 Yasuhiro Matsumoto

**License :** MIT License

Please see above.


**Software :** github.com/mattn/go-tty v0.0.3

**Copyright notice :** Copyright (c) 2018 Yasuhiro Matsumoto

**License :** MIT License

Please see above.


**Software :** github.com/mgutz/ansi v0.0.0-20170206155736-9520e82c474b

**Copyright notice :** Copyright (c) 2013 Mario Gutierrez mario@mgutz.com
Copyright (c) 2013 Mario L. Gutierrez

**License :** MIT License

Please see above.


**Software :** github.com/pkg/term v1.1.0

**Copyright notice :** Copyright (c) 2014, David Cheney

**License :** BSD 2-Clause "Simplified" License

  
  
  Copyright (c) <year> <owner>.
  
 Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
  
   1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


**Software :** github.com/pmezard/go-difflib v1.0.0

**Copyright notice :** Copyright (c) 2013, Patrick Mezard

**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** github.com/rivo/uniseg v0.2.0

**Copyright notice :** Copyright (c) 2019 Oliver Kuederle

**License :** MIT License

Please see above.


**Software :** github.com/sirupsen/logrus v1.8.1

**Copyright notice :** Copyright (c) 2012 Miki Tebeka <miki.tebeka@gmail.com>
Copyright (c) 2014 Simon Eskildsen

**License :** MIT License

Please see above.


**Software :** github.com/stretchr/objx v0.1.0

**Copyright notice :** Copyright (c) 2014 Stretchr, Inc.
Copyright (c) 2017-2018 objx contributors

**License :** MIT License

Please see above.


**Software :** github.com/stretchr/testify v1.7.0

**Copyright notice :** Copyright (c) 2012-2020 Mat Ryer, Tyler Bunnell and contributors.

**License :** MIT License

Please see above.


**Software :** github.com/yuin/goldmark v1.4.13

**Copyright notice :** Copyright (c) 2019 Yusuke Inuzuka


**License :** MIT License

Please see above.


**Software :** go-prompt v0.2.6

**Copyright notice :** Copyright (c) 2017 Masashi SHIBATA


**License :** MIT License

Please see above.


**Software :** golang.org/x/crypto v0.7.0

**Copyright notice :** Copyright (c) 2009 The Go Authors
Copyright 2015 The Go Authors
Copyright 2018 The Go Authors
Copyright 2019 The Go Authors
Copyright 2016 The Go Authors
Copyright 2017 The Go Authors
Copyright 2011 The Go Authors
Copyright 2010 The Go Authors
Copyright 2012 The Go Authors
Copyright (c) 2017 The Go Authors
Copyright (c) 2019 The Go Authors
Copyright (c) 2020 The Go Authors
Copyright (c) 2021 The Go Authors
Copyright 2014 The Go Authors
Copyright 2020 The Go Authors
Copyright 2022 The Go Authors
Copyright 2009 The Go Authors
Copyright 2013 The Go Authors

**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** golang.org/x/mod v0.8.0

**Copyright notice :** "Copyright (c) 2009 The Go Authors
Copyright 2019 The Go Authors
Copyright 2018 The Go Authors
Copyright 2021 The Go Authors
Copyright 2020 The Go Authors"

**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** golang.org/x/net v0.8.0

**Copyright notice :** Copyright (c) 2009 The Go Authors
Copyright 2016 The Go Authors
Copyright 2017 The Go Authors
Copyright 2014 The Go Authors
Copyright 2015 The Go Authors
Copyright 2010 The Go Authors
Copyright 2009 The Go Authors
Copyright 2023 The Go Authors
Copyright 2011 The Go Authors
Copyright 2013 The Go Authors
Copyright 2012 The Go Authors
Copyright (c) 2009 Apple Inc.
Copyright 2018 The Go Authors
Copyright 2021 The Go Authors
(c) cc.fr
Copyright 2022 The Go Authors
Copyright 2020 The Go Authors
Copyright 2019 The Go Authors
(c) if err p.JoinGroup en0, &net.UDPAddr IP group


**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** golang.org/x/sync v0.1.0

**Copyright notice :** Copyright (c) 2009 The Go Authors
Copyright 2016 The Go Authors
Copyright 2017 The Go Authors
Copyright 2013 The Go Authors
Copyright 2019 The Go Authors


**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** golang.org/x/sys v0.0.0-20220829200755-d48e67d00261

**Copyright notice :** Copyright (c) 2009 The Go Authors
Copyright 2018 The Go Authors
Copyright 2019 The Go Authors
Copyright 2020 The Go Authors
Copyright 2022 The Go Authors
Copyright 2014 The Go Authors
Copyright 2009 The Go Authors
Copyright 2012 The Go Authors
Copyright 2011 The Go Authors
Copyright 2015 The Go Authors
Copyright 2013 The Go Authors
Copyright 2021 The Go Authors
Copyright 2016 The Go Authors
Copyright 2017 The Go Authors
Copyright 2010 The Go Authors
Copyright 2009,2010 The Go Authors

**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** golang.org/x/term v0.6.0

**Copyright notice :** Copyright (c) 2009 The Go Authors
Copyright 2019 The Go Authors
Copyright 2013 The Go Authors
Copyright 2021 The Go Authors
Copyright 2011 The Go Authors


**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** golang.org/x/text v0.8.0

**Copyright notice :** Copyright 2015 The Go Authors
Copyright (c) 2009 The Go Authors
Copyright 2014 The Go Authors
Copyright 2016 The Go Authors
Copyright 2017 The Go Authors
Copyright 2012 The Go Authors
Copyright 2021 The Go Authors
Copyright 2013 The Go Authors
Copyright 2019 The Go Authors
(c) AeHa (c)
(c) aA"AE (c) 1AE
(c) lEEe (c) AE
(c) EeAoq (c)
(c) (c) A
(c) EmeEBu (c)
(c) (c) AAEE
(c) EAiE (c)
(c) Bv
(c) oav!A (c) AY I
(c) uSSg1/2a+-N (c) OY
Copyright 2018 The Go Authors
Copyright 2009 The Go Authors
Copyright 2011 The Go Authors


**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** golang.org/x/tools v0.6.0

**Copyright notice :** Copyright (c) 2009 The Go Authors
Copyright 2014 The Go Authors
Copyright 2013 The Go Authors
Copyright 2018 The Go Authors
Copyright 2009 The Go Authors
Copyright 2019 The Go Authors
Copyright 2015 The Go Authors
Copyright 2021 The Go Authors
Copyright 2017 The Go Authors
Copyright (c) 2017 The Go Authors
Copyright 2010 The Go Authors
Copyright 2016 The Go Authors
Copyright 2011 The Go Authors
Copyright (c) 1994-1999 Lucent Technologies Inc.
Portions Copyright (c) 1995-1997 C H Forsyth (forsyth@terzarima.net)
Portions Copyright (c) 1997-1999 Vita Nuova Limited
Portions Copyright (c) 2000-2007 Vita Nuova Holdings Limited (www.vitanuova.com)
Portions Copyright (c) 2004,2006 Bruce Ellis
Portions Copyright (c) 2005-2007 C H Forsyth (forsyth@terzarima.net)
Copyright (c) 2000-2007 Lucent Technologies Inc. and others
Portions Copyright (c) 2009 The Go Authors
Copyright 2012 The Go Authors
Copyright 2013 jQuery Foundation and other contributors
Copyright 2020 The Go Authors
Copyright 2022 The Go Authors
Copyright 2023 The Go Authors
Copyright Jorn Zaefferer

**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** golang.org/x/xerrors v0.0.0-20190717185122-a985d3407aa7

**Copyright notice :** Copyright 2019 The Go Authors
Copyright 2011 The Go Authors
Copyright 2018 The Go Authors
Copyright 2012 The Go Authors
Copyright (c) 2019 The Go Authors

**License :** BSD 3-Clause "New" or "Revised" License

Please see above.


**Software :** gopkg.in/check.v1 v0.0.0-20161208181325-20d25e280405

**Copyright notice :** Copyright (c) 2012 The Go Authors
Copyright (c) 2010-2013 Gustavo Niemeyer <gustavo@niemeyer.net>

**License :** BSD 2-Clause "Simplified" License

Please see above.


**Software :** gopkg.in/yaml.v2 v2.2.8

**Copyright notice :** Copyright 2011-2016 Canonical Ltd.
Copyright (c) 2006 Kirill Simonov

**License :** Apache License 2.0

Please see above.


**Software :** gopkg.in/yaml.v3 v3.0.0-20200313102051-9f266ea9e77c

**Copyright notice :** Copyright (c) 2011-2019 Canonical Ltd
Copyright (c) 2006-2010 Kirill Simonov
Copyright 2011-2016 Canonical Ltd.
Copyright (c) 2006-2011 Kirill Simonov

**License :** Apache License 2.0

Please see above.


**Software :** gopkg.in/yaml.v3 v3.0.0-20200313102051-9f266ea9e77c

**Copyright notice :** Copyright (c) 2011-2019 Canonical Ltd
Copyright (c) 2006-2010 Kirill Simonov
Copyright 2011-2016 Canonical Ltd.
Copyright (c) 2006-2011 Kirill Simonov

**License :** MIT License

Please see above.


### Written Offer
This product contains software whose rights holders license it on the terms of the GNU General Public License, version 2 (GPLv2) and/or other open source software licenses. We will provide you and any third party with the source code of the software licensed under an open source software license if you send us a written request by mail or email to the following addresses:

foss@huawei.com

detailing the name of the product and the firmware version for which you need the source code and indicating how we can contact you.

Please note you need to make a payment before you obtain the complete Corresponding Source Code from us. For how much you will pay and how we will deliver the complete Corresponding Source Code to you, we will further discuss it by mail or email.

This offer is valid to anyone in receipt of this information.

**THIS OFFER IS VALID FOR THREE YEARS FROM THE MOMENT WE DISTRIBUTED THE PRODUCT OR FIRMWARE.**